package ru.dbotthepony.mc.otm.menu

import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterDecomposer
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import net.minecraft.world.SimpleContainer
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.matter.MatterRegistry
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.orNull

class MenuMatterDecomposer @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: BlockEntityMatterDecomposer? = null
) : MenuMatteryPowered(Registry.Menus.MATTER_DECOMPOSER, containerID, inventory, tile) {
	val input: MatterySlot
	val output: MachineOutputSlot
	val progressWidget: ProgressGaugeWidget
	val matterWidget: LevelGaugeWidget

	init {
		val container = tile?.itemContainer ?: SimpleContainer(2)

		// Вход
		input = object : MatterySlot(container, 0, 61, 36) {
			override fun mayPlace(p_40231_: ItemStack): Boolean {
				return MatterRegistry.canDecompose(p_40231_)
			}
		}

		addSlot(input)

		// Выход
		output = MachineOutputSlot(container, 1, 61 + 18 + 10 + 3 + 22, 36)
		addSlot(output)

		matterWidget = LevelGaugeWidget(this, tile?.getCapability(MatteryCapability.MATTER)?.orNull())

		if (tile == null) {
			progressWidget = ProgressGaugeWidget(this)
		} else {
			progressWidget = ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess)
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 2
	}
}